Ekylibre Plugin System, overview
-----

The plugin system is based around a dependency injection container. All services that are shared between parts of the code should be registered so they can be built by the container and the instance shared.

Unlike PHP, a Rails application is noc completely reset between two calls, so the base of the application is shared among multiple (all) clients.
Ekylibre being a mult-tenant application, special care is to be used to effectively separate services that are specific to a tenant.
This is done by having (at least) two dependency injection container in the application, (the second one fallbacks to the first one automatically):
- The application container that contains services related to the entire app, its base data, nomenclature, etc.
- For each request, a Request container, that contains all services needing information on the tenant it should work with, the current user, etc. It is destroyed (and the services defined it it at the end of each request).

# Requirements
## Service definition
For most of the cases, a service is an instance of a class and a single instance is enough. The container should provide a way to easily register a service by its class so that it can be easily queried when needed.

In some other cases, multiple instance of a class are needed (file loaders, providers, etc.) so it should still be possible to provide a specific ID when registering a service.

## Extension through providers and registries
For Procedo and other similar components that have an extensible set of elements that can be registered, it should be possible to automatically provide them additional configuration without having to patch a class or a service.  

The solution if in two parts:
- Anonymous services (that have their ID generated by the container)
- Tagged services for which the container is able to provides as an array of service to services that requires it. This way, adding configuration is only done by defining a service with the correct tag and its if automatically picked up by already existing services when they are created.

# Existing Implementation(s)

## dry-rb with dry-container
### Features
It seems that the Rails ecosystem is missing a Container implementation that provides all the needed functionalities.
The only real container implementation found is [dry-container](https://dry-rb.org/gems/dry-container/0.8/)

With dry-container, services are registered as Proc with a strigified key. By default, instances are not reused.
Extensions can be created via modules that are included in the Container class and a DSL is provided to register services.

dry-rb also provides more Gems related to the container, namingly `dry-auto_inject`

### Pros and Cons
However, tagged services are not provided natively but they can be implemented with a custom implementation for the container (the default implementation is a Mixin).

The default behavior is to create a new instance of the service each time it is requested. However, with the option `memoize` used when registering the service, only one instance is created. The API does not seem to provide a way to clear the memoized services which will be necessary in development mode to reset the services after reloading the classes.

Having to register services using a block is very flexible but can be very verbose when a lot of services need to be declared.  Definig services with a block allows the developer to easily define a custom service with a very flexible API as the service definition is plain Ruby code.
With this implementation, however, service declarations cannot be introspected as they are hidden with custom block code. Instances also need to be manually creates which can be cumbersome when the API changes as the service definition is usually in a different file as the service class.

# New and Custom implementation
## Corindon and its DependencyInjection component
Corindon has been written based on the need extracted from the second version of the plugin system, this explains why all the requirements are met (or should be met).

Conrindon dependency injection mechanism is based on a `Container` working in conjunction with an `Injector` that is responsible to construct a service based on a `Definition`. A Definition can be created manually or in the class itself through a DSL provided by a refinment. This DSL allows to define the requirements of the service declaratively in the class implementing this service. The DSL is also availble when providing a block to the `Container::register` method.

Once a class declares how it can be built, registering it as a service (or getting its instance from the Container) is just a matter of providing its `Class` object to the Container.

Services can be tagged and the container is able to provide a list of service IDs for a given tag.

